#!/bin/sh

DN=$(cd $(dirname $0) ; pwd)

unset NODE_EXE
UNAME_R=$(uname -r)

case $UNAME_R in
  3.*) [[ -f "${0%.sh}" ]] && NODE_EXE="${0%.sh}" ;;
  2.6.*)
    REL=(${UNAME_R//[-.]/ }) ; REL2=${REL[2]//[^0-9]/}
    [[ ${REL2:-0} -ge 27 && -f "${0%.sh}" ]] && NODE_EXE="${0%.sh}" ;;
esac

if [[ -n $NODE_EXE ]] ; then
  # use nodejs from epages-nodejs.rpm
  PATH="$DN:$PATH"
else
  # use nodejs from nodejs.rpm
  . /etc/default/${EPAGES_PROJECT:-epages6}
  [[ -f /etc/SuSE-release ]] && exe=node || exe=nodejs
  if [[ ! -e "$EPAGES/bin/$exe" ]] ; then
    rm -f "$EPAGES/bin/$exe"
    chmod 644 $DN/$exe 2>/dev/null
    which_exe=$(type -p $exe) || which $exe
    chmod 755 $DN/$exe 2>/dev/null
    [[ -z $which_exe ]] && exit 1
    ( cd "$EPAGES/bin" && ln -sf $which_exe $exe )
  fi
  [[ -f /etc/SuSE-release ]] && other=nodejs || other=node
  if [[ ! -e "$EPAGES/bin/$other" ]] ; then
    rm -f "$EPAGES/bin/$other"
    ( cd "$EPAGES/bin" && ln -sf $exe $other )
  fi
  if [[ ! -e "$EPAGES/bin/npm" && -f "$DN/nodejs.d/lib/node_modules/npm/bin/npm-cli.js" ]]
  then
    rm -f "$EPAGES/bin/npm"
    ( cd "$EPAGES/bin" && ln -s "$DN/nodejs.d/lib/node_modules/npm/bin/npm-cli.js" npm )
  fi
  [[ -x "$EPAGES/bin/npm" ]] || chmod 755 "$EPAGES/bin/npm"
  PATH="$EPAGES/bin:$PATH"
  NODE_EXE="$EPAGES/bin/nodejs"
fi

export NODE_PATH=$DN/nodejs.d/lib/node_modules
$NODE_EXE "$@"
